



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>bzoj 1801: [Ahoi2009]chess 中国象棋</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">bzoj 1801: [Ahoi2009]chess 中国象棋</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 04:43:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Description</h2>
<div>在N行M列的棋盘上，放若干个炮可以是0个，使得没有任何一个炮可以攻击另一个炮。 请问有多少种放置方法，中国像棋中炮的行走方式大家应该很清楚吧.</div>
<h2>Input</h2>
<div>一行包含两个整数N，M，中间用空格分开.</div>
<h2>Output</h2>
<div>输出所有的方案数，由于值比较大，输出其mod 9999973</div>
<h2>Sample Input</h2>
<div>1 3
</div>
<h2>Sample Output</h2>
<div>7
</div>
<h2>HINT</h2>
<div>
<p>除了在3个格子中都放满炮的的情况外，其它的都可以.</p>
<p>100%的数据中N,M不超过100<br />50%的数据中，N,M至少有一个数不超过8<br />30%的数据中，N,M均不超过6</p>
</div>
<h2>Source</h2>
<div>
<p><a href="http://www.lydsy.com/JudgeOnline/problemset.php?search=Day2" rel="external nofollow noreferrer">Day2</a></p>
<p>通过象棋的规则，每行每列最多两个炮。。</p>
<p>那么每行最多放两个，并且不能放在已经有两个炮的列上。。</p>
<p>那么设dp[i][j][k]表示到了第i行，有j列没有放，有k列只放了一个炮的方案数。。。</p>
<p>那么对于每一行，可以用组合数大力讨论这[0,2]个炮怎么放，总共6种情况，然后加法原理加起来。。。</p>
<p>暴力得不行。。。</p>
<div>
<pre class="prettyprint linenums">// MADE BY QT666<br />
#include&lt;cstdio&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;cstring&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
const int N=100050;<br />
const int Mod=9999973;<br />
ll jc[N],inv[N],dp[105][105][105],n,m;<br />
ll qpow(ll a,ll b){ll ans=1;while(b){if (b&amp;1) (ans*=a)%=Mod;(a*=a)%=Mod,b&gt;&gt;=1;}return ans;}<br />
ll C(int n,int m){<br />
  return jc[n]*inv[m]%Mod*inv[n-m]%Mod;<br />
}<br />
int main(){<br />
  scanf("%d%d",&amp;n,&amp;m);<br />
  jc[0]=1;for(int i=1;i&lt;=m;i++) (jc[i]=jc[i-1]*i)%=Mod;<br />
  for(int i=0;i&lt;=m;i++) inv[i]=qpow(jc[i],Mod-2);<br />
  dp[0][m][0]=1;<br />
  for(int i=1;i&lt;=n;i++){<br />
    for(int j=0;j&lt;=m;j++){<br />
      for(int k=0;k&lt;=m;k++){<br />
    (dp[i][j][k]+=dp[i-1][j][k])%=Mod;<br />
    if(k-1&gt;=0) (dp[i][j][k]+=C(j+1,1)*dp[i-1][j+1][k-1])%=Mod;<br />
    if(k-2&gt;=0) (dp[i][j][k]+=C(j+2,2)*dp[i-1][j+2][k-2])%=Mod;<br />
    (dp[i][j][k]+=C(k+1,1)*dp[i-1][j][k+1])%=Mod;<br />
    (dp[i][j][k]+=C(k+2,2)*dp[i-1][j][k+2])%=Mod;<br />
    (dp[i][j][k]+=C(j+1,1)*C(k,1)%Mod*dp[i-1][j+1][k])%=Mod;<br />
      }<br />
    }<br />
  }<br />
  ll ans=0;<br />
  for(int i=0;i&lt;=m;i++)<br />
    for(int j=0;j&lt;=m;j++)(ans+=dp[n][i][j])%=Mod;<br />
  printf("%lld\n",ans);<br />
  return 0;<br />
}
</pre>
</div>
<p>　　</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq15x609.html">MIT 6&period;828 JOS学习笔记8&period; Exercise 1&period;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eoxpmq.html">PHP 常用函数的解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93vzzr8.html">WCF服务客户端首页调用慢的问题处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r33zm9.html">tornado 非阻塞方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6jv4q.html">nyoj1007&lpar;euler 函数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mz7meq.html">self进行weak化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgen3q.html">简单风格 在线音乐播放器（支持wav，MP3等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgrr3q.html">1046&colon; &lbrack;HAOI2007&rsqb;上升序列 - BZOJ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zog67xq.html">JavaScript语言基础知识6</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgdg5m8.html">Linux Kbuild工作原理分析&lpar;以DVSDK生成PowerVR显卡内核模块为例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgg4578.html">js控制图片缩放、水平和垂直方向居中对齐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0prr8.html">For循环及例题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4j5r8.html">java jackson 忽略不存在的属性字段 和 按照属性名转json</a>
		</li>
						<li><a href="https://www.batexi.com/a/960yz7n9.html">ASP&period;NET WebApi技术从入门到实战演练</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdl6r9.html">数据库的IO and 数据库优化问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kr749.html">Eclipse开发时出现HTTP 403 错误（禁止访问）的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5p5erq.html">51Nod-1006【LCS】&plus;【输出路径】模板题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q254jywq.html">&lpar;C&sol;C&plus;&plus;学习笔记&rpar; 二十&period; 文件和流</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vn0jq.html">MySql 新建用户与数据库的实际操作步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk1d5v8.html">Android通知栏沉浸式&sol;透明化完整解决方案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy10z7gq.html">安卓自定义控件（二）BitmapShader、ShapeDrawable、Shape</a>
			</li>
						<li><a href="https://www.batexi.com/a/950741e8.html">简易RPC框架-熔断降级机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyrnpz9.html">IPv6 VS IPv4，谈谈升级 IPv6 的必要性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy10ej2q.html">企业实战Nginx&plus;Tomcat动静分离架构的技术分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj2jxpq.html">labview生成可执行文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzx1dg8.html">【docker 一】入门实践、环境部署、基本操作指令、镜像库、数据卷</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p40en8.html">tensorflow MNIST新手教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/950n3re8.html">SAP GUI 750 安装包 及 补丁3 共享</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjlnzx8.html">quzrtz的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p43r48.html">用js解析XML文件，字符串一些心得</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
